#pragma once

#define UPDATE_INTERVAL .016
#define OPENGL_MAJOR 3
#define OPENGL_MINOR 3

class CScene;

class CApplication
{

#pragma region Singleton
private:
	static CApplication * instance;
public:
	static CApplication * GetInstance(void) {
		if (instance == NULL) {
			instance = new CApplication();
		}
		return instance;
	}
#pragma endregion

public:
	void InitWindow(void);
	void InitGL(void);
	void ProcessEvents(void);
	void Cleanup(void);
	double GetTime(void);
	void Redraw(void);
	void Update(void);
	void GameLoop(void);
	void Start(void);

	static void GLFWCALL OnWindowSize(int w, int h);

	int WindowWidth;
	int WindowHeight;

private:
	CApplication(void);
	~CApplication(void);

};

