#include "StdAfx.h"
#include "Camera.h"


CCamera::CCamera(void)
{
	nearPlane = .01f;
	farPlane = 100.0f;
	viewportWidth = 16;
	viewportWidth = 10;
	fieldOfView = 45.0f;
	position = glm::vec3(0.0f, 0.0f, 5.0f);
	direction = glm::vec3(0.0f, 0.0f, -1.0f);
	up = glm::vec3(0.0f, 1.0f, 0.0f);
}


CCamera::~CCamera(void)
{
}

void CCamera::SetPosition(glm::vec3 p) {
	position = p;
	UpdateViewMatrix();
}

void CCamera::SetDirection(glm::vec3 d) {
	direction = d;
	UpdateViewMatrix();
}

void CCamera::SetUp(glm::vec3 u) {
	up = u;
	UpdateViewMatrix();
}

void CCamera::SetViewport(int w, int h) {
	viewportWidth = w;
	viewportHeight = h;
	UpdateProjectionMatrix();
}

void CCamera::UpdateProjectionMatrix(void) {
	ProjectionMatrix = glm::perspective(45.0f, viewportWidth / viewportHeight, nearPlane, farPlane);
}

void CCamera::UpdateViewMatrix(void) {
	ViewMatrix = glm::lookAt(position, position + direction, up);
}
