#pragma once
class CCamera
{
public:
	CCamera(void);
	~CCamera(void);

	glm::mat4 ProjectionMatrix;
	glm::mat4 ViewMatrix;

	void SetViewport(int w, int h);
	void SetPosition(glm::vec3 p);
	void SetDirection(glm::vec3 d);
	void SetUp(glm::vec3 u);

	void UpdateProjectionMatrix(void);
	void UpdateViewMatrix(void);

protected:
	// Projection:
	float viewportWidth;
	float viewportHeight;
	float fieldOfView;
	float nearPlane;
	float farPlane;

	// View:
	glm::vec3 position;
	glm::vec3 direction;
	glm::vec3 up;
};

