#include "StdAfx.h"
#include "Light.h"


CLight::CLight(void) : CNode()
{
}


CLight::~CLight(void)
{
}
	
void CLight::Init(void) {

}
	
void CLight::Bind(int id) {
	glm::mat4 ModelMatrix = glm::rotate(Rotation.x, glm::vec3(1, 0, 0)) * glm::rotate(Rotation.y, glm::vec3(0, 1, 0)) * glm::rotate(Rotation.z, glm::vec3(0, 0, 1)) * glm::translate(Position);
	glm::mat4 ModelViewMatrix = Scene->Camera.ViewMatrix * ModelMatrix;
	glm::vec3 v3Position = glm::vec3(ModelViewMatrix * glm::vec4(0, 0, 0, 1));

	char uName[64];

	sprintf_s(uName, "%s[%d].%s", GLSL_UNIFORM_NAME_LIGHTS_ARRAY, id, GLSL_UNIFORM_NAME_LIGHT_POSITION);
	glUniform3fv(CShadingProgram::GetCurrent()->GetUniformLocation(uName), 1, glm::value_ptr(v3Position));
	
	sprintf_s(uName, "%s[%d].%s", GLSL_UNIFORM_NAME_LIGHTS_ARRAY, id, GLSL_UNIFORM_NAME_LIGHT_AMBIENT);
	glUniform3fv(CShadingProgram::GetCurrent()->GetUniformLocation(uName), 1, glm::value_ptr(Ambient));
	
	sprintf_s(uName, "%s[%d].%s", GLSL_UNIFORM_NAME_LIGHTS_ARRAY, id, GLSL_UNIFORM_NAME_LIGHT_DIFFUSE);
	glUniform3fv(CShadingProgram::GetCurrent()->GetUniformLocation(uName), 1, glm::value_ptr(Diffuse));
	
	sprintf_s(uName, "%s[%d].%s", GLSL_UNIFORM_NAME_LIGHTS_ARRAY, id, GLSL_UNIFORM_NAME_LIGHT_SPECULAR);
	glUniform3fv(CShadingProgram::GetCurrent()->GetUniformLocation(uName), 1, glm::value_ptr(Specular));
}

void CLight::SetLightsNumber(int n) {
	glUniform1i(CShadingProgram::GetCurrent()->GetUniformLocation(GLSL_UNIFORM_NAME_LIGHT_NUM), n);
}
