#include "StdAfx.h"
#include "Point.h"


CPoint::CPoint(void) : CRenderableNode()
{
	Primitive = GL_POINTS;
}


CPoint::~CPoint(void)
{
}


void CPoint::PrepareGeometryBuffer(void) {
	CRenderableNode::PrepareGeometryBuffer();

	NumVertices = 1;

	GLfloat * buf = new GLfloat[VBO_STRIDE * NumVertices];

	int i = 0;
	buf[(3 * i + 0) * VBO_STRIDE + 0] = 0.0f;
	buf[(3 * i + 0) * VBO_STRIDE + 1] = 0.0f;
	buf[(3 * i + 0) * VBO_STRIDE + 2] = 0.0f;
	buf[(3 * i + 0) * VBO_STRIDE + 3] = 0.0f;
	buf[(3 * i + 0) * VBO_STRIDE + 4] = 0.0f;
	buf[(3 * i + 0) * VBO_STRIDE + 5] = 1.0f;
	
	glBufferData(GL_ARRAY_BUFFER, VBO_STRIDE * 1 * sizeof(GLfloat), buf, GL_STATIC_DRAW);

	delete[] buf;
}

void CPoint::PrepareGeometryPointers(void) {
	CRenderableNode::PrepareGeometryPointers();
	
	glVertexAttribPointer(_GLSL_VERTEX_POSITION_POS, 3, GL_FLOAT, GL_FALSE, VBO_STRIDE * sizeof(GLfloat), 0);
	glVertexAttribPointer(_GLSL_VERTEX_NORMAL_POS, 3, GL_FLOAT, GL_FALSE, VBO_STRIDE * sizeof(GLfloat), (const GLvoid *) (3 * sizeof(GLfloat)));
	glEnableVertexAttribArray(_GLSL_VERTEX_POSITION_POS);
	glEnableVertexAttribArray(_GLSL_VERTEX_NORMAL_POS);
}
