#version 330 core

layout(location = 0) in vec3 v3Position;
layout(location = 1) in vec3 v3Normal;

out VertexData {
	vec3 v3Normal;
	vec3 v3Eye;
} PerVertex;

uniform mat4 m4ModelViewProjection;
uniform mat4 m4ModelView;
uniform mat3 m3Normal;

void main(void) {
	PerVertex.v3Eye = vec3(m4ModelView * vec4(v3Position, 1));
	PerVertex.v3Normal = m3Normal * v3Normal;
	gl_Position = m4ModelViewProjection * vec4(v3Position, 1);
}
