#version 330 core

layout(points) in;
layout(triangle_strip, max_vertices=4) out;

in VertexData {
	vec3 v3Eye;
} VertexIn[];

out VertexData {
	vec3 v3Eye;
	vec2 v2TexCoord;
} VertexOut;

uniform mat4 m4Projection;
uniform vec2 v2ParticleSize;

void main() {
	vec2 v2Size = v2ParticleSize / 2;
	
	VertexOut.v2TexCoord = vec2(0.0, 1.0);
	VertexOut.v3Eye = VertexIn[0].v3Eye + vec3(-v2Size.x, v2Size.y, 0.0);
	gl_Position = m4Projection * vec4(VertexOut.v3Eye, 1.0);
	EmitVertex();
	
	VertexOut.v2TexCoord = vec2(0.0, 0.0);
	VertexOut.v3Eye = VertexIn[0].v3Eye + vec3(-v2Size.x, -v2Size.y, 0.0);
	gl_Position = m4Projection * vec4(VertexOut.v3Eye, 1.0);
	EmitVertex();
	
	VertexOut.v2TexCoord = vec2(1.0, 1.0);
	VertexOut.v3Eye = VertexIn[0].v3Eye + vec3(v2Size.x, v2Size.y, 0.0);
	gl_Position = m4Projection * vec4(VertexOut.v3Eye, 1.0);
	EmitVertex();
	
	VertexOut.v2TexCoord = vec2(1.0, 0.0);
	VertexOut.v3Eye = VertexIn[0].v3Eye + vec3(v2Size.x, -v2Size.y, 0.0);
	gl_Position = m4Projection * vec4(VertexOut.v3Eye, 1.0);
	EmitVertex();
}
