#pragma once

#define GLSL_UNIFORM_NAME_MODELVIEWPROJECTION_MATRIX "m4ModelViewProjection"
#define GLSL_UNIFORM_NAME_MODELVIEW_MATRIX "m4ModelView"
#define GLSL_UNIFORM_NAME_NORMAL_MATRIX "m3Normal"
#define GLSL_UNIFORM_NAME_PROJECTION_MATRIX "m4Projection"

#define GLSL_UNIFORM_NAME_MATERIAL "mdMaterial"
#define GLSL_UNIFORM_NAME_MATERIAL_AMBIENT "v3Ambient"
#define GLSL_UNIFORM_NAME_MATERIAL_DIFFUSE "v3Diffuse"
#define GLSL_UNIFORM_NAME_MATERIAL_SPECULAR "v3Specular"
#define GLSL_UNIFORM_NAME_MATERIAL_SHININESS "fShininess"

#define GLSL_UNIFORM_NAME_LIGHT_NUM "iLights"
#define GLSL_UNIFORM_NAME_LIGHTS_ARRAY "ldLights"
#define GLSL_UNIFORM_NAME_LIGHT_POSITION "v3Position"
#define GLSL_UNIFORM_NAME_LIGHT_AMBIENT "v3Ambient"
#define GLSL_UNIFORM_NAME_LIGHT_DIFFUSE "v3Diffuse"
#define GLSL_UNIFORM_NAME_LIGHT_SPECULAR "v3Specular"
#define GLSL_UNIFORM_STRUCT_SIZE_LIGHT 4

#define GLSL_UNIFORM_NAME_PARTICLE_SIZE "v2ParticleSize"

class CShadingProgram
{
public:
	CShadingProgram(void);
	~CShadingProgram(void);

	GLuint Id;

	void Activate(void);
	static void Deactivate(void);

	void AttachShader(GLenum type, const char *path);

	GLint GetUniformLocation(const char *name);

protected:
	void Link(void);

	bool isLinked;
	bool isVertexShaderAttached;
	bool isFragmentShaderAttached;

	std::vector<GLuint> shaderIds;

private:
	static CShadingProgram * Current;
public:
	static CShadingProgram * GetCurrent(void);
};

