#include "StdAfx.h"
#include "TestScene.h"


CTestScene::CTestScene(void) : CScene()
{
	// Budowa cieki (okrelenie kolejnych wzw)
	MovementPath.push_back(glm::vec3(-4.0f, 0.0f, 0.0f));
	MovementPath.push_back(glm::vec3(-1.0f, 1.0f, 0.0f));
	MovementPath.push_back(glm::vec3(1.0f, -2.0f, 0.0f));
	MovementPath.push_back(glm::vec3(3.0f, 3.0f, 0.0f));
	MovementPath.push_back(glm::vec3(4.0f, -1.0f, 0.0f));
	MovementPath.push_back(glm::vec3(0.5f, -3.5f, 0.0f));
	MovementPath.push_back(glm::vec3(-3.0f, 3.5f, 0.0f));
}


CTestScene::~CTestScene(void)
{
}

void CTestScene::Init(void) {
	CScene::Init();

	Camera.SetPosition(glm::vec3(0.0f, 0.0f, 10.0f));
	
	// Dodanie wiata
	{
		CLight * l = new CLight();
		l->Scene = this;
		l->Position = glm::vec3(0.0f, 10.0f, -2.0f);
		l->Ambient = glm::vec3(1.0f, 1.0f, 1.0f);
		l->Diffuse = glm::vec3(1.0f, 1.0, 1.0f);
		l->Specular = glm::vec3(1.0f, 1.0f, 1.0f);
		Lights.push_back(l);
	}

	// Dodanie wzw cieki
	int i = 0;
	for (vector<glm::vec3>::iterator it = MovementPath.begin(); it != MovementPath.end(); ++it, ++i) {
		CSphere * node = new CSphere(4);

		node->Position = glm::vec3(*it);
		node->Scale = glm::vec3(.1f);

		node->MaterialAmbient = glm::vec3(1.0f, .6f, .1f);
		node->MaterialDiffuse = glm::vec3(0.0f, 0.0f, 0.0f);
		node->MaterialSpecular = glm::vec3(0.0f, 0.0f, 0.0f);
		node->MaterialAmbient.r = (float)i / (MovementPath.size() - 1);

		AddNode(node);
	}

	// Dodanie kuli
	{
		CSphere * node = new CSphere(5);

		node->Position = glm::vec3(0.0f, 0.0f, 0.0f);
		node->Scale = glm::vec3(.5f, .5f, .5f);

		node->MaterialAmbient = glm::vec3(.2f, .12f, .02f);
		node->MaterialDiffuse = glm::vec3(1.0f, .6f, .1f);
		node->MaterialSpecular = glm::vec3(1.0f, 1.0f, 1.0f);

		AddNode(node);

		Ball = node;
	}

}

void CTestScene::Redraw(void) {
	SP_General->Activate();

	CScene::Redraw();
}

void CTestScene::Update(void) {
	CScene::Update();

	// Aktualizacja pooenia kuli
	Ball->Position = MovementPath[0];
}

